routes/web.php
<?php

use App\Http\Controllers\AuthorController;
use App\Http\Controllers\BookController;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/weather', [Controller::class, 'weather'])->name('weather');

Route::group(['middleware' => 'auth'], function () {
    Route::get('/', [Controller::class, 'home'])->name('home');

    Route::group(['prefix' => '/books', 'as' => 'book.'], function () {
        Route::get('/', [BookController::class, 'index'])->name('index');
        Route::get('/create', [BookController::class, 'create'])->name('create');
        Route::get('/{id}', [BookController::class, 'show'])->name('show');
        Route::get('/{id}/edit', [BookController::class, 'edit'])->name('edit');
        Route::get('/{id}/delete', [BookController::class, 'delete'])->name('delete');

        Route::post('/', [BookController::class, 'store'])->name('store');
        Route::post('/{id}/update', [BookController::class, 'update'])->name('update');
        Route::post('/{id}/delete', [BookController::class, 'destroy'])->name('destroy');
    });

    Route::group(['prefix' => '/authors', 'as' => 'author.'], function () {
        Route::get('/', [AuthorController::class, 'index'])->name('index');
        Route::get('/create', [AuthorController::class, 'create'])->name('create');
        Route::get('/{id}', [AuthorController::class, 'show'])->name('show');
        Route::get('/{id}/edit', [AuthorController::class, 'edit'])->name('edit');
        Route::get('/{id}/delete', [AuthorController::class, 'delete'])->name('delete');

        Route::post('/', [AuthorController::class, 'store'])->name('store');
        Route::post('/{id}/update', [AuthorController::class, 'update'])->name('update');
        Route::post('/{id}/delete', [AuthorController::class, 'destroy'])->name('destroy');
    });

});

require __DIR__ . '/auth.php';

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Book extends Model
{
    use HasFactory;

    protected $fillable = ['title', 'description', 'isbn', 'author_id', 'price', 'rate', 'pages', 'publishing'];

    public function author()
    {
        return $this->belongsTo(Author::class, 'author_id', 'id');
    }

    public function owner()
    {
        return $this->belongsTo(User::class, 'owner_id', 'id');
    }


    public function getPreviewImagePathAttribute()
    {
        return @$this->images()->first()->path ?? $this->defaultImage();
    }

    public function images()
    {
        return $this->hasMany(Image::class, 'book_id', 'id');
    }

    public function defaultImage()
    {
        return "";
    }
}

resources/views/library/authors.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container-fluid">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                                <h4 class="card-title">Author Lists</h4>
                            </div>
                            <div class="iq-card-header-toolbar d-flex align-items-center">
                                <a href="{{route('author.create')}}" class="btn btn-primary">Add New author</a>
                            </div>
                        </div>
                        <div class="iq-card-body">
                            @include('components.search')
                            @if(count($authors) > 0)
                                <div class="table-responsive">
                                    <table class="table table-striped table-bordered" style="width:100%">
                                        <thead>
                                        <tr>
                                            <th style="width: 3%;">
                                                <span>No</span>
                                                <span>{{{view('components.arrow', ['column' => 'id'])}}}</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Author Image</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Author Name</span>
                                                <span>{{{view('components.arrow', ['column' => 'name'])}}}</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Author Books</span>
                                                <span>{{{view('components.arrow', ['column' => 'books_count'])}}}</span>
                                            </th>
                                            <th style="width: 15%;">Action</th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        @foreach($authors as $author)
                                            <tr>
                                                <td>{{$loop->index + 1}}</td>
                                                <td><img class="img-fluid rounded " style="width: 64px;" src="/storage/{{$author->image_path}}" alt=""></td>
                                                <td>{{$author->name}}</td>
                                                <td>{{$author->books_count}}</td>
                                                <td>
                                                    <div class="flex align-items-center list-user-action">
                                                        <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="View"
                                                           href="{{route('author.show', $author->id)}}"><i
                                                                class="ri-eye-line"></i></a>
                                                        @can('update-author', $author)
                                                            <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit"
                                                               href="{{route('author.edit', $author->id)}}"><i
                                                                    class="ri-pencil-line"></i></a>
                                                        @endcan
                                                        @can('update-author', $author)
                                                            <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Delete"
                                                               href="{{route('author.delete', $author->id)}}"><i
                                                                    class="ri-delete-bin-line"></i></a>
                                                        @endcan
                                                    </div>
                                                </td>
                                            </tr>
                                        @endforeach
                                        </tbody>
                                    </table>
                                    @include('components.pagination', ['skip' => $skip, 'take' => $take, 'total' => $total])
                                </div>
                            @else
                                <h3> OPPS! No matching results </h3>
                                <a href="{{route('author.index')}}">Clear filters</a>
                            @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/library/books.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container-fluid">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                                <h4 class="card-title">Book Lists</h4>
                            </div>
                            <div class="iq-card-header-toolbar d-flex align-items-center">
                                <a href="{{route('book.create')}}" class="btn btn-primary">Add New book</a>
                            </div>
                        </div>
                        <div class="iq-card-body">
                            @include('components.search')
                            @if(count($books) > 0)
                                <div class="table-responsive">
                                    <table class="table table-striped table-bordered" style="width:100%">
                                        <thead>
                                        <tr>
                                            <th style="width: 3%;">
                                                <span>No</span>
                                                <span>{{{view('components.arrow', [ 'column' => 'id'])}}}</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Image</span>
                                            </th>
                                            <th style="width: 8%;">
                                                <span>Title</span>
                                                <span>{{{view('components.arrow', [ 'column' => 'name'])}}}</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Author</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>ISBN</span>
                                                <span>{{{view('components.arrow', [ 'column' => 'isbn'])}}}</span>
                                            </th>
                                            <th style="width: 30%;">
                                                <span>Description</span>
                                                <span>{{{view('components.arrow', [ 'column' => 'description'])}}}</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Price</span>
                                                <span>{{{view('components.arrow', [ 'column' => 'price'])}}}</span>
                                            </th>
                                            <th style="width: 10%;">
                                                <span>Pages</span>
                                                <span>{{{view('components.arrow', [ 'column' => 'pages'])}}}</span>
                                            </th>
                                            <th style="width: 10px;">Action</th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        @foreach($books as $book)
                                            <tr>
                                                <td>{{$loop->index + 1}}</td>
                                                <td><img class="img-fluid rounded" src="/storage/{{$book->preview_image_path}}" alt=""></td>
                                                <td>{{$book->title}}</td>
                                                <td>{{$book->author->name}}</td>
                                                <td>{{$book->isbn}}</td>
                                                <td>
                                                    <p class="mb-0">{{$book->description}}</p>
                                                </td>
                                                <td>${{$book->price}}</td>
                                                <td>{{$book->pages}} Pages</td>
                                                <td>
                                                    <div class="d-flex align-items-center list-user-action justify-content-center">
                                                        <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="View" href="{{route('book.show', $book->id)}}"><i
                                                                class="ri-eye-line"></i></a>

                                                        @can('update-book', $book)
                                                            <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit"
                                                               href="{{route('book.edit', $book->id)}}"><i
                                                                    class="ri-pencil-line"></i></a>
                                                        @endcan

                                                        @can('update-book', $book)
                                                            <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Delete"
                                                               href="{{route('book.delete', $book->id)}}"><i
                                                                    class="ri-delete-bin-line"></i></a>
                                                        @endcan
                                                    </div>
                                                </td>
                                            </tr>
                                        @endforeach
                                        </tbody>
                                    </table>
                                    @include('components.pagination', ['skip' => $skip, 'take' => $take, 'total' => $total])
                                </div>
                            @else
                                <h3> OPPS! No matching results </h3>
                                <a href="{{route('book.index')}}">Clear filters</a>
                            @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/library/create-author.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                                <h4 class="card-title">Add Author</h4>
                            </div>
                        </div>
                        <div class="iq-card-body">
                            <form action="{{route('author.store')}}" method="post">
                                @csrf()
                                <div class="form-group">
                                    <label>Author Name:</label>
                                    <input type="text" name="name" class="form-control" value="{{old('name')}}">
                                </div>
                                <button type="submit" class="btn btn-primary">Submit</button>
                                <button type="reset" class="btn btn-danger">Reset</button>
                            </form>

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection

resources/views/library/delete-author.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                                <h4 class="card-title">Are you sure that you want to delete the author?</h4>
                                <h5><a href="{{route('author.show', $author->id)}}">{{$author->name}}</a></h5>
                            </div>
                        </div>

                        <div class="iq-card-body">
                            @if(count($author->books) > 0)
                                <div class="mb-3 d-block">
                                    <p>You cannot able to delete the author before delete the following books</p>
                                    <ul>
                                        @foreach($author->books as $book)
                                            <li><a href="{{route('book.show', $book->id)}}"> {{$book->title}} </a></li>
                                        @endforeach
                                    </ul>
                                </div>
                            @endif
                            <form action="{{route('author.destroy', $author->id)}}" method="post">
                                @csrf()
                                <button type="submit" class="btn btn-danger">Delete</button>
                                <button onclick="window.location.href='{{route('author.index')}}'" type="reset" class="btn btn-secondary">Cancel</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/library/delete-book.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                                <h4 class="card-title">Are you sure that you want to delete the book?</h4>
                                <h5><a href="{{route('book.show', $book->id)}}"> {{$book->title }}</a></h5>
                            </div>
                        </div>
                        <div class="iq-card-body">
                            <form action="{{route('book.destroy', $book->id)}}" method="post">
                                @csrf()
                                <button type="submit" class="btn btn-danger">Delete</button>
                                <button onclick="window.location.href='{{route('book.index')}}'" type="reset" class="btn btn-secondary">Cancel</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/library/edit-author.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                                <h4 class="card-title">Edit Author</h4>
                            </div>
                        </div>
                        <div class="iq-card-body">
                            <form action="{{route('author.update', $author->id)}}" method="post">
                                @csrf()
                                <div class="form-group">
                                    <label>Author Name:</label>
                                    <input type="text" name="name" class="form-control" value="{{old('name', $author->name)}}">
                                </div>
                                <button type="submit" class="btn btn-primary">Update</button>
                                <button onclick="window.location.href='{{route('author.index')}}'" type="reset" class="btn btn-secondary">Cancel</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/library/show-author.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card iq-card-block iq-card-stretch iq-card-height">
                        <div class="iq-card-header d-flex justify-content-between align-items-center">
                            <h4 class="card-title mb-0">Author Information</h4>
                            @can('update-author', $author)
                                <div class="flex align-items-center list-user-action">
                                    <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit" href="{{route('author.edit', $author->id)}}"><i
                                            class="ri-pencil-line"></i></a>
                                    <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Delete" href="{{route('author.delete', $author->id)}}"><i
                                            class="ri-delete-bin-line"></i></a>
                                </div>
                            @endcan
                        </div>
                        <div class="iq-card-body pb-0">
                            <div class="description-contens align-items-top row">
                                <div class="col-md-auto">
                                    <div class="iq-card-transparent iq-card-block iq-card-stretch iq-card-height">
                                        <div class="iq-card-body p-0">
                                            <div class="row align-items-center">
                                                <a href="javascript:void(0);">
                                                    <img src="/storage/{{$author->image_path}}" class="img-fluid rounded" style="width: 128px;" alt="">
                                                </a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-10">
                                    <div class="iq-card-transparent iq-card-block iq-card-stretch iq-card-height">
                                        <div class="iq-card-body p-0">
                                            <h3 class="mb-3">{{$author->name}}</h3>
                                            <div class="mb-3 d-block">
                                                <b>Author Books:</b>
                                                <ul>
                                                    @foreach($author->books as $book)
                                                        <li><a href="{{route('book.show', $book->id)}}"> {{$book->title}} </a></li>
                                                    @endforeach
                                                </ul>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/library/show-book.blade.php
@extends('layouts.library')

@section('content')
    <div id="content-page" class="content-page">
        <div class="container-fluid">
            <div class="row">
                <div class="col-sm-12">
                    <div class="iq-card iq-card-block iq-card-stretch iq-card-height">
                        <div class="iq-card-header d-flex justify-content-between align-items-center">
                            <h4 class="card-title mb-0">Books Description</h4>
                            @can('update-book', $book)
                                <div class="flex align-items-center list-user-action">
                                    <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit" href="{{route('book.edit', $book->id)}}"><i
                                            class="ri-pencil-line"></i></a>
                                    <a class="bg-primary" data-toggle="tooltip" data-placement="top" title="" data-original-title="Delete" href="{{route('book.delete', $book->id)}}"><i
                                            class="ri-delete-bin-line"></i></a>
                                </div>
                            @endcan

                        </div>
                        <div class="iq-card-body pb-0">
                            <div class="description-contens align-items-top row">
                                <div class="col-md-4">
                                    <div class="iq-card-transparent iq-card-block iq-card-stretch iq-card-height">
                                        <div class="iq-card-body p-0">
                                            <div class="row align-items-center">
                                                <div class="col-3">
                                                    <ul id="description-slider-nav" class="list-inline p-0 m-0  d-flex align-items-center">
                                                        @foreach($book->images as $image)
                                                            <li>
                                                                <a href="/storage/{{$image->path}}">
                                                                    <img src="/storage/{{$image->thumbnail_path}}" class="img-fluid rounded w-100" alt="">
                                                                </a>
                                                            </li>
                                                        @endforeach
                                                    </ul>
                                                </div>
                                                <div class="col-9">
                                                    <ul id="description-slider" class="list-inline p-0 m-0  d-flex align-items-center">
                                                        @foreach($book->images as $image)
                                                            <li>
                                                                <a href="/storage/{{$image->path}}">
                                                                    <img src="/storage/{{$image->path}}" class="img-fluid rounded w-100" alt="">
                                                                </a>
                                                            </li>
                                                        @endforeach
                                                    </ul>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-8">
                                    <div class="iq-card-transparent iq-card-block iq-card-stretch iq-card-height">
                                        <div class="iq-card-body p-0">
                                            <h3 class="mb-3">{{$book->title}}</h3>
                                            <div class="price d-flex align-items-center font-weight-500 mb-2">
                                                <span class="font-size-24 text-dark">${{$book->price}}</span>
                                            </div>
                                            <div class="mb-3 d-block">
                                          <span class="font-size-20 text-warning">
                                                @for($i=0; $i<$book->rate; $i++)
                                                  <i class="fa fa-star mr-1"></i>
                                              @endfor
                                          </span>
                                            </div>
                                            <span class="text-dark mb-4 pb-4 iq-border-bottom d-block">{{$book->description}}</span>
                                            <div class="text-primary mb-4">Author: <a href="{{route('author.show', $book->author->id)}}">
                                                    <span class="text-body">{{$book->author->name}}</span>
                                                </a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection